local leadWire = ...

--------------------------------------------------------------------------
local LEAD_WIRE_ALIGN_COMP = {
	TypeName = _PrefixAsset .. "LEAD_WIRE_ALIGN_COMP",
	ParentType = "COMPONENT",
	Properties = {}
}

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:create()
    self.InitialPosition = nil
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:init()
        self.WindowPosition = self:getOwner():getGlobalPosition()
        self.InitialPosition = self:getOwner():getGlobalPosition()
        leadWire:log("InitialPosition = " .. tostring(self.InitialPosition))
        leadWire:log("Start GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
        if self:computeElevation() then
            self:getOwner():setGlobalPosition(self.WindowPosition)  
            leadWire:log("<<<<<<Elevation y = " .. self.WindowPosition[2])
        end
        self.LeadWire_PositionY = self.WindowPosition[2]
        leadWire:log("End GlobalPosition = " .. tostring(self:getOwner():getGlobalPosition()))
end

function LEAD_WIRE_ALIGN_COMP:restorePosition()
        leadWire:log("restore InitialPosition = " .. tostring(self.InitialPosition))
        if self.InitialPosition == nil then
            leadWire:log("InitialPosition nil")
            return
        end
        self:getOwner():setGlobalPosition(self.InitialPosition)
        leadWire:log("restore InitialPosition end")
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:computeElevation()
        local LeadWireName = _PrefixAsset .. "LEAD_WIRE_COMP"
       
        local _currentObject = self:getOwner() 
        local _leadWire
        for i=0,20, 1 do
            local _parent = _currentObject:getParent()
            if _parent == nil then    
                return false
            end
            if _parent.Name == _PrefixAsset .. "MONUMENT_NAME" then    
                _leadWire = _parent:findFirstObjectWithComponentDown(LeadWireName)        
                if _leadWire == nil then
                    return false
                else
                    break
                end
            end
            _currentObject = _parent
        end
        if not _leadWire.LeadWire_IsSet then
            return false
        end
        if _leadWire:getOwner() == nil then    
            return false
        end
        local _leadWireObject = _leadWire:getOwner()
        self.WindowPosition[2] = _leadWireObject:getGlobalPosition()[2]
        return true       
end

--------------------------------------------------------------------------
function LEAD_WIRE_ALIGN_COMP:update()
--[[
        if self.LeadWire_PositionY == self:getOwner():getGlobalPosition()[2] then
            return
        end
        if self:computeElevation() then
            self:getOwner():setGlobalPosition(self.WindowPosition)  
            leadWire:log("++++++Elevation y = " .. self.WindowPosition[2])
        end
]]
end

--------------------------------------------------------------------------
leadWire:registerClass(LEAD_WIRE_ALIGN_COMP)
